// Example of using the PVision library for interaction with the Pixart sensor on a WiiMote
// This work was derived from Kako's excellent Japanese website
// http://www.kako.com/neta/2007-001/2007-001.html

// Steve Hobley 2009 - www.stephenhobley.com
#include <Wire.h>
#include <PVision.h>
#include <SPI.h>
#include <WiFi101.h>
#include <OSCMessage.h>
#include <WiFiUdp.h>

WiFiUDP Udp;
PVision ircam;

int IRsensorAddress = 0xB0;
//int IRsensorAddress = 0x58;
int slaveAddress;

IPAddress outIp(2,1,1,109);// receiver IP
const unsigned int outPort = 9999;

byte result;
char ssid[] = "your network";      // your network SSID (name)
char pass[] = "your password";   // your network password
int keyIndex = 0;                 // your network key Index number (needed only for WEP)

int status = WL_IDLE_STATUS;
WiFiServer server(80);
byte myMac[] = {  
  0xF8, 0xF0, 0x05, 0xF5, 0xE4, 0xF1 }; // you can find this written on the board of some Arduino Ethernets or shields
  

void setup() {
    
  // Connect to WPA/WPA2 network. Change this line if using open or WEP network:
  status = WiFi.begin(ssid, pass);
  // wait 10 seconds for connection:
  delay(10000);
  server.begin();
  Udp.begin (8888);
  // you're connected now, so print out the status:
  IPAddress ip = WiFi.localIP();
  ircam.init();
}

void loop()
{
   
   result = ircam.read();

   if (result & BLOB1)
  {
  //the message wants an OSC address as first argument
  OSCMessage blob1x("/blob1/x");
  blob1x.add(ircam.Blob1.X);
  
  Udp.beginPacket(outIp, outPort);
  blob1x.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob1x.empty(); // free space occupied by message

  OSCMessage blob1y("/blob1/y");
  blob1y.add(ircam.Blob1.Y);
  
  Udp.beginPacket(outIp, outPort);
  blob1y.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob1y.empty(); // free space occupied by message  

  OSCMessage blob1size("/blob1/size");
  blob1size.add(ircam.Blob1.Size);
  
  Udp.beginPacket(outIp, outPort);
  blob1size.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob1size.empty(); // free space occupied by message  
  }

  if (result & BLOB2)
  {
  OSCMessage blob2x("/blob2/x");
  blob2x.add(ircam.Blob2.X);
  
  Udp.beginPacket(outIp, outPort);
  blob2x.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob2x.empty(); // free space occupied by message

  OSCMessage blob2y("/blob2/y");
  blob2y.add(ircam.Blob2.Y);
  
  Udp.beginPacket(outIp, outPort);
  blob2y.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob2y.empty(); // free space occupied by message 

  OSCMessage blob2size("/blob2/size");
  blob2size.add(ircam.Blob2.Size);
  
  Udp.beginPacket(outIp, outPort);
  blob2size.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob2size.empty(); // free space occupied by message

  }
  
  if (result & BLOB3)
  {
  OSCMessage blob3x("/blob3/x");
  blob3x.add(ircam.Blob3.X);
  
  Udp.beginPacket(outIp, outPort);
  blob3x.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob3x.empty(); // free space occupied by message

  OSCMessage blob3y("/blob3/y");
  blob3y.add(ircam.Blob3.Y);
  
  Udp.beginPacket(outIp, outPort);
  blob3y.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob3y.empty(); // free space occupied by message 

  OSCMessage blob3size("/blob3/size");
  blob3size.add(ircam.Blob3.Size);
  
  Udp.beginPacket(outIp, outPort);
  blob3size.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob3size.empty(); // free space occupied by message 
  }

  if (result & BLOB4)
  {

  OSCMessage blob4x("/blob4/x");
  blob4x.add(ircam.Blob4.X);
  
  Udp.beginPacket(outIp, outPort);
  blob4x.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob4x.empty(); // free space occupied by message

  OSCMessage blob4y("/blob4/y");
  blob4y.add(ircam.Blob4.Y);
  
  Udp.beginPacket(outIp, outPort);
  blob4y.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob4y.empty(); // free space occupied by message 

  OSCMessage blob4size("/blob4/size");
  blob4size.add(ircam.Blob4.Size);
  
  Udp.beginPacket(outIp, outPort);
  blob4size.send(Udp); // send the bytes to the SLIP stream
  Udp.endPacket(); // mark the end of the OSC Packet
  blob4size.empty(); // free space occupied by message 
  } 


  delay(100);    

   
}



